"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const prelude_js_1 = require("./prelude.js");
const balance = (_) => {
    switch (true) {
        // balance B (T R (T R a x b) y c) z d = T R (T B a x b) y (T B c z d)
        case _?.c === prelude_js_1.B && _.l?.c === prelude_js_1.R && _.l.l?.c === prelude_js_1.R: {
            const { l: { l: { l: a, v: x, n: i, r: b }, v: y, n: j, r: c }, v: z, n: k, r: d } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance B (T R a x (T R b y c)) z d = T R (T B a x b) y (T B c z d)
        case _.c === prelude_js_1.B && _.l?.c === prelude_js_1.R && _.l.r?.c === prelude_js_1.R: {
            const { l: { l: a, v: x, n: i, r: { l: b, v: y, n: j, r: c } }, v: z, n: k, r: d } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance B a x (T R (T R b y c) z d) = T R (T B a x b) y (T B c z d)
        case _.c === prelude_js_1.B && _.r?.c === prelude_js_1.R && _.r.l?.c === prelude_js_1.R: {
            const { l: a, v: x, n: i, r: { l: { l: b, v: y, n: j, r: c }, v: z, n: k, r: d } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance B a x (T R b y (T R c z d)) = T R (T B a x b) y (T B c z d)
        case _.c === prelude_js_1.B && _.r?.c === prelude_js_1.R && _.r.r?.c === prelude_js_1.R: {
            const { l: a, v: x, n: i, r: { l: b, v: y, n: j, r: { l: c, v: z, n: k, r: d } } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.R, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance BB a x (T R (T R b y c) z d) = T B (T B a x b) y (T B c z d)
        case _.c === prelude_js_1.BB && _.r?.c === prelude_js_1.R && _.r.l?.c === prelude_js_1.R: {
            const { l: a, v: x, n: i, r: { l: { l: b, v: y, n: j, r: c }, v: z, n: k, r: d } } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance BB (T R a x (T R b y c)) z d = T B (T B a x b) y (T B c z d)
        case _.c === prelude_js_1.BB && _.l?.c === prelude_js_1.R && _.l.r?.c === prelude_js_1.R: {
            const { l: { l: a, v: x, n: i, r: { l: b, v: y, n: j, r: c } }, v: z, n: k, r: d } = _;
            return (0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.B, a, x, i, b), y, j, (0, prelude_js_1.mk)(prelude_js_1.B, c, z, k, d));
        }
        // balance color a x b = T color a x b
        default:
            return _;
    }
};
exports.default = balance;
//# sourceMappingURL=balance.js.map