"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const prelude_js_1 = require("./prelude.js");
const Cmp = __importStar(require("@prelude/cmp"));
const rotate_js_1 = __importDefault(require("./rotate.js"));
const shift_js_1 = __importDefault(require("./shift.js"));
const delete_ = (_, key, cmpB, i) => {
    switch (true) {
        // del E = E
        case _ === prelude_js_1.E:
            return [undefined, 0, prelude_js_1.E];
        case _ === prelude_js_1.EE:
            throw new Error('Unexpected EE.');
        // del (T R E y E) | x == y = E
        //                 | x /= y = T R E y E
        case _?.c === prelude_js_1.R && _.l === prelude_js_1.E && _.r === prelude_js_1.E: {
            const { v: y, n: j } = _;
            return cmpB(key(y)) === Cmp.equal ?
                j <= i ?
                    [y, j - i, prelude_js_1.E] :
                    [undefined, j - i, (0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, y, j - i, prelude_js_1.E)] :
                [undefined, 0, _];
        }
        // del (T B E y E) | x == y = EE
        //                 | x /= y = T B E y E
        case _?.c === prelude_js_1.B && _.l === prelude_js_1.E && _.r === prelude_js_1.E: {
            const { v: y, n: j } = _;
            return cmpB(key(y)) === Cmp.equal ?
                j <= i ?
                    [y, j - i, prelude_js_1.EE] :
                    [undefined, j - i, (0, prelude_js_1.mk)(prelude_js_1.B, prelude_js_1.E, y, j - i, prelude_js_1.E)] :
                [undefined, 0, _];
        }
        // del (T B (T R E y E) z E)
        // | x < z = T B (del (T R E y E)) z E
        // | x == z = T B E y E
        // | x > z = T B (T R E y E) z E
        case _?.c === prelude_js_1.B && _.l?.c === prelude_js_1.R && _.l.l === prelude_js_1.E && _.l.r === prelude_js_1.E && _.r === prelude_js_1.E: {
            const { l: { v: y, n: j }, v: z, n: k } = _;
            const cmp_ = cmpB(key(z));
            switch (cmp_) {
                case Cmp.asc: {
                    const [v, n, r] = delete_((0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, y, j, prelude_js_1.E), key, cmpB, i);
                    return [v, n, (0, prelude_js_1.mk)(prelude_js_1.B, r, _.v, _.n, prelude_js_1.E)]; // TODO: ?
                }
                case Cmp.equal:
                    return i >= k ?
                        [z, k - i, (0, prelude_js_1.mk)(prelude_js_1.B, prelude_js_1.E, y, j, prelude_js_1.E)] :
                        [z, k - i, (0, prelude_js_1.mk)(prelude_js_1.B, (0, prelude_js_1.mk)(prelude_js_1.R, prelude_js_1.E, y, j, prelude_js_1.E), z, k - i, prelude_js_1.E)];
                case Cmp.dsc:
                    return [undefined, 0, _];
                default:
                    throw new TypeError(`Expected cmp result, got ${cmp_}.`);
            }
        }
        // del (T c a y b)
        // | x < y = rotate c (del a) y b
        // | x == y = let (y’,b’) = min_del b in rotate c a y’ b’
        // | x > y = rotate c a y (del b)
        default: {
            const { c, l: a, v: y, n: j, r: b } = _;
            const cmp_ = cmpB(key(y));
            switch (cmp_) {
                case Cmp.asc: {
                    const [v, n, r] = delete_(a, key, cmpB, i);
                    return [v, n, (0, rotate_js_1.default)((0, prelude_js_1.mk)(c, r, y, j, b))];
                }
                case Cmp.equal: {
                    const [y_, j_, b_] = (0, shift_js_1.default)(b);
                    return [y, j_, (0, rotate_js_1.default)((0, prelude_js_1.mk)(c, a, y_, j_, b_))];
                }
                case Cmp.dsc: {
                    const [v, n, r] = delete_(b, key, cmpB, i);
                    return [v, n, (0, rotate_js_1.default)((0, prelude_js_1.mk)(c, a, y, j, r))];
                }
                default:
                    throw new TypeError(`Expected cmp result, got ${cmp_}.`);
            }
        }
    }
};
exports.default = delete_;
//# sourceMappingURL=delete.js.map