import * as RbTree from './rb-tree';
import Cmp = RbTree.Cmp;
declare type E<K, V> = [K, V];
declare type Map_<K, V> = {
    tree: RbTree.t<E<K, V>, K>;
};
export { Map_ as Map, Map_ as t, Cmp };
export declare const of: <K, V>(cmp: RbTree.Cmp.t<K>) => Map_<K, V>;
export declare const set: <K, V>(map: Map_<K, V>, key: K, value: V) => void;
export declare const maybeGet: <K, V>(map: Map_<K, V>, key: K) => V | undefined;
export declare const get: <K, V>(map: Map_<K, V>, key: K) => V;
export declare const has: <K, V>(map: Map_<K, V>, key: K) => boolean;
/**
 * Deletes left most element.
 * @returns left most element.
 * @throws if map is empty.
 */
export declare const shift: <K, V>(map: Map_<K, V>) => V;
/**
 * Iterates over keys.
 * Modifications inside iteration are allowed.
 * Iteration will yield keys as they were during initial invocation.
 */
export declare const keys: <K, V>(map: Map_<K, V>) => Generator<K, any, unknown>;
export declare const values: <K, V>(map: Map_<K, V>) => Generator<V, any, unknown>;
export declare const entries: <K, V>(map: Map_<K, V>) => Generator<[K, V], any, unknown>;
